


// Name
//===================================
//
// Block
//


// DEPENDENCIES
//===================================

    #include "block.h"
    #include "block_type.h"
    #include <iostream>


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    Block::Block
    (
    )
    :
        Object( NULLVAL, NULLVAL ),
        type_ ( nullptr )
    {};

    // DO NOT DELETE BLOCK TYPE. Owned by other class; this holds just a copy.
    Block::~Block() {};

    void Block::render( Graphics& graphics, Camera& camera )
    {
        if ( type_ != nullptr )
            type_->render( graphics, camera, *this );
    };

    void Block::neutralize()
    {
        used_ = false;
        physics_bound_box_.x = NULLVAL;
        physics_bound_box_.y = NULLVAL;
        type_ = nullptr;
    };

    void Block::setBlock( int x, int y, BlockType* type, int location )
    {
        used_ = true;
        physics_bound_box_.x = Unit::PixelsToSubPixels( x );
        physics_bound_box_.y = Unit::PixelsToSubPixels( y );
        type_ = type;
        location_ = location;
    };

    const BlockType::BlockAction Block::type() const
    {
        if ( type_ != nullptr )
            return type_->action();
    };

    int Block::location() const
    {
        return location_;
    };
