

// Name
//===================================
//
// Block
//

#ifndef BLOCK_H
#define BLOCK_H


// FORWARD DECLARATIONS
//===================================

    class BlockType;
    class Map;
    class Sprite;
    class SpriteGraphics;


// DEPENDENCIES
//===================================

    #include "block_type.h"
    #include "object.h"


// CLASS
//===================================

    class Block : public Object
    {
        public:
            friend class BlockSystem;
            Block();
            ~Block();
            void render( Graphics& graphics, Camera& camera );
            const BlockType::BlockAction type() const;
            int location() const;

        private:
            static const int NULLVAL = -99999;
            BlockType* type_ = nullptr; // COPY; owned by other object.
            int location_ = NULLVAL;
            bool used_ = false;

            void neutralize();
            void setBlock( int x, int y, BlockType* type, int location );
    };

#endif // BLOCK_H
