
// Name
//===================================
//
// Collision
//


// DEPENDENCIES
//===================================

    #include "collision.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    Collision::Collision
    (
        int overlap_x_left,
        int overlap_x_right,
        int overlap_y_top,
        int overlap_y_bottom
    )
    :
        overlap_x_left_   ( overlap_x_left ),
        overlap_x_right_  ( overlap_x_right ),
        overlap_y_top_    ( overlap_y_top ),
        overlap_y_bottom_ ( overlap_y_bottom )
    {};

    int Collision::overlapXLeft() const
    {
        return overlap_x_left_;
    };
    int Collision::overlapXRight() const
    {
        return overlap_x_right_;
    };
    int Collision::overlapYTop() const
    {
        return overlap_y_top_;
    };
    int Collision::overlapYBottom() const
    {
        return overlap_y_bottom_;
    };
    bool Collision::collideLeft() const
    {
        return overlapXLeft() > 0;
    };
    bool Collision::collideRight() const
    {
        return overlapXRight() > 0;
    };
    bool Collision::collideTop() const
    {
        return overlapYTop() > 0;
    };
    bool Collision::collideBottom() const
    {
        return overlapYBottom() > 0;
    };
    bool Collision::collideAny() const
    {
        return ( collideLeft() || collideRight() || collideTop() || collideBottom() );
    };
