

// Name
//===================================
//
// Counter
//


#ifndef COUNTER_H
#define COUNTER_H

// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================


// CLASS
//===================================

    class Counter
    {
        public:
            Counter
            (
                int init_value = 0,
                int upper_limit = 0,
                int lower_limit = 0,
                bool reset = false,
                bool flip = false
            );

            void operator+  ( int n );
            void operator-  ( int n );
            void operator++ ();
            void operator-- ();
            void operator=  ( int n );

            int value() const;

            void reset();


        private:
            static const int UPPER_LIMIT_NULL = 0;
            static const int LOWER_LIMIT_NULL = 0;

            int init_value_  = -1;
            int value_       = -1;
            int upper_limit_ = -1;
            int lower_limit_ = -1;

            bool reset_ = false;
            bool flip_ = false;

            int test_value_decrease( int n ) const;
            int test_value_increase( int n ) const;
    };

#endif // COUNTER_H
