

// Name
//===================================
//
// GameState
//


#ifndef GAME_STATE_H
#define GAME_STATE_H


// FORWARD DECLARATIONS
//===================================

    class Game;
    class Graphics;
	class Input;


// DEPENDENCIES
//===================================

    #include "camera.h"
    #include "palette.h"


// CLASS
//===================================

    class GameState
    {
        public:
            GameState
            (
                Palette::PaletteSet palette = { Palette::PaletteType::GRAYSCALE, 1 }
            );
            virtual ~GameState();

            void render( Graphics& graphics );

            virtual void update( Game& game, Input& input, Graphics& graphics ) = 0;
            virtual void stateRender( Graphics& graphics ) = 0;
            virtual void init( Game& game, Graphics& graphics ) = 0;
            virtual void backFromPop( Game& game, Graphics& graphics ) = 0;
            void changePalette( Graphics& graphics );
            void newPalette( Graphics& graphics, Palette::PaletteSet pallete );

        private:
            Palette::PaletteSet palette_;
    };

#endif // GAME_STATE_H
