


// Name
//===================================
//
// Level
//

#ifndef LEVEL_H
#define LEVEL_H


// FORWARD DECLARATIONS
//===================================

    class Camera;
    class GameState;
    class Goal;
    class Graphics;
    class Sprite;


// DEPENDENCIES
//===================================

    #include "map.h"
    #include "warp.h"
    #include <vector>


// CLASS
//===================================

    class Level
    {
        public:
            enum LevelName
            {
                LV_CITY_1,
                LV_LIMIT
            };

            Level( LevelName level = LevelName::LV_CITY_1 );
            ~Level();
            Map& currentMap();

            int entranceX() const;
            int entranceY() const;
            int cameraX() const;
            int cameraY() const;
            void warp( int n, Sprite& sprite, Camera& camera, GameState* state, Graphics& graphics );
            Goal* goal() const;

        private:
            std::vector<Map> maps_;
            std::vector<Warp> warps_;
            Goal* goal_ = nullptr;
            int current_map_ = 0;
            int default_entrance_x_ = 0;
            int default_entrance_y_ = 0;
            int entrance_x_ = 0;
            int entrance_y_ = 0;
            int camera_x_ = 0;
            int camera_y_ = 0;

            bool testCurrentMap();
            bool testWarp( int n ) const;
            void reset();
    };

#endif // LEVEL_H

