


// Name
//===================================
//
// LevelState
//


// DEPENDENCIES
//===================================

    #include "game.h"
    #include "goal.h"
    #include "level_state.h"
    #include "message_state.h"
    #include "title_state.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    LevelState::LevelState( bool show_message )
    :
        show_message_ ( show_message )
        //GameState( level_.currentMap().palette() )
    {
    };

    LevelState::~LevelState() {};

    void LevelState::update( Game& game, Input& input, Graphics& graphics )
    {
        blocks_.blocksFromMap( level_.currentMap(), camera_ );
        hero_.update( input, camera_, level_.currentMap(), game, events_ );
        blocks_.collide( hero_, level_, events_, inventory_, camera_, this, graphics );
        camera_.adjust( hero_, level_.currentMap().widthPixels(), level_.currentMap().heightPixels() );
        level_.goal()->update( inventory_, events_ );

        if ( input.pressed( Input::Action::EXTRA1 ) )
            events_.won_ = true;

        if ( hero_.isDead() )
            game.changeState( std::unique_ptr<GameState> ( new LevelState( false ) ) );
        else if ( events_.won_ )
        {
            game.changeState( std::unique_ptr<GameState> ( new MessageState( "¡La victolía es tu!", false, std::unique_ptr<GameState> ( new TitleState() ) ) ) );
        }
    };

    void LevelState::stateRender( Graphics& graphics )
    {
        blocks_.render( graphics, camera_ );
        hero_.render( graphics, camera_ );
        inventory_.render( graphics );
    };

    void LevelState::init( Game& game, Graphics& graphics )
    {
        newPalette( graphics, level_.currentMap().palette() );

        if ( show_message_ )
            game.pushState( std::unique_ptr<GameState> ( new MessageState( level_.goal()->message(), true ) ) );
    };


    void LevelState::backFromPop( Game& game, Graphics& graphics ) {};
