

// Name
//===================================
//
// LevelState
//

#ifndef LEVEL_STATE_H
#define LEVEL_STATE_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "block_system.h"
    #include "camera.h"
    #include "game_state.h"
    #include "event_system.h"
    #include "inventory.h"
    #include "level.h"
    #include "sprite.h"
    #include "player_graphics.h"
    #include "player_movement.h"


// CLASS
//===================================

    class LevelState : public GameState
    {

        public:
            LevelState( bool show_message = true );
            ~LevelState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            bool show_message_ = true;
            Level level_;
            Camera camera_ = Camera( level_.cameraX(), level_.cameraY() );
            EventSystem events_;
            Inventory inventory_;
            BlockSystem blocks_;
            Sprite hero_ = Sprite( new PlayerGraphics(), new PlayerMovement(), level_.entranceX(), level_.entranceY(), 16, 24, Sprite::Type::HERO );
    };

#endif // LEVEL_STATE_H
