
// Name
//===================================
//
// SpriteGraphics
//

#ifndef SPRITE_GRAPHICS_H
#define SPRITE_GRAPHICS_H


// FORWARD DECLARATIONS
//===================================

    class Camera;
    class Sprite;


// DEPENDENCIES
//===================================

    #include "graphics.h"


// CLASS
//===================================

    class SpriteGraphics
    {
        public:
            SpriteGraphics
            (
                Graphics::SpriteSheet texture = Graphics::SpriteSheet::LIMIT,
                int current_frame_x = 0,
                int current_frame_y = 0,
                bool flip_x = false,
                bool flip_y = false
            );
            virtual ~SpriteGraphics();
            virtual void update( Sprite& sprite );
            void render( Graphics& graphics, SDL_Rect bound_box, Camera* camera );
            void adjustBoundBox( SDL_Rect new_box );
            bool visible_ = true;

        protected:
            Graphics::SpriteSheet texture_ = Graphics::SpriteSheet::LIMIT;
            bool flip_x_ = false;
            bool flip_y_ = false;
            int current_frame_x_ = 0;
            int current_frame_y_ = 0;
            int prev_frame_x_ = 0;
            int prev_frame_y_ = 0;

            int cutoffLeft  ( int object_x, int camera_x ) const;
            int cutoffTop   ( int object_y, int camera_y ) const;
            int cutoffRight ( int object_x, int camera_x, int object_w, int camera_w ) const;
            int cutoffBottom( int object_y, int camera_y, int object_h, int camera_h ) const;
            int cutoffLeft  ( SDL_Rect& obj_r, Camera& c ) const;
            int cutoffTop   ( SDL_Rect& obj_r, Camera& c ) const;
            int cutoffRight ( SDL_Rect& obj_r, Camera& c ) const;
            int cutoffBottom( SDL_Rect& obj_r, Camera& c ) const;
    };


#endif // SPRITE_GRAPHICS_H

