




// Name
//===================================
//
// TitleState
//

#ifndef TITLE_STATE_H
#define TITLE_STATE_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "game_state.h"
    #include "sprite_graphics.h"
    #include "text.h"
    #include <vector>


// CLASS
//===================================

    class TitleState : public GameState
    {

        public:
            TitleState();
            ~TitleState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            const int INSTRUCTION_Y_START = 72;
            const int INSTRUCTION_Y_SPACE = 8;
            SpriteGraphics logo_gfx_ = SpriteGraphics( Graphics::SpriteSheet::BOSKO_LOGO );
            SDL_Rect logo_rect_ = { 0, 0, 320, 48 };
            std::vector<Text> text_ =
            {
                //Text( "Boskeopolis Land", 8, 8, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER ),
                Text( "J. J. W. Mezun", 8, 48, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER ),
                //Text( "In-Game Controls:", 8, INSTRUCTION_Y_START-8, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER ),
                Text( "Z = Jump", 8, INSTRUCTION_Y_START, Text::FontShade::BLACK ),
                Text( "X = Run", 8, INSTRUCTION_Y_START+INSTRUCTION_Y_SPACE, Text::FontShade::BLACK ),
                Text( "C = Menu", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*2), Text::FontShade::BLACK ),
                Text( "A = Scroll Camera Leftward", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*3), Text::FontShade::BLACK ),
                Text( "S = Scroll Camera Rightward", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*4), Text::FontShade::BLACK ),
                Text( "UP = Scroll Camera Upward", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*5), Text::FontShade::BLACK ),
                Text( "DOWN = Duck, Scroll Camera Downward", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*6), Text::FontShade::BLACK ),
                Text( "LEFT & RIGHT = Move left & right", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*7), Text::FontShade::BLACK ),
                //Text( "ESC = Force Quit Program", 8, INSTRUCTION_Y_START+(INSTRUCTION_Y_SPACE*8), Text::FontShade::BLACK ),
                Text( "Press Z to Continue", 8, Unit::WINDOW_HEIGHT_PIXELS - 32, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER, true ),
                Text( "Press C to Quit", 8, Unit::WINDOW_HEIGHT_PIXELS - 16, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER )
            };
    };

#endif // TITLE_STATE_H
